package big3d.collision;

import java.util.ArrayList;

import big3d.camera.Camera;


public class CollisionComputer {
	
	protected Camera cam;
	protected ArrayList<CollisionObject> objects;
	
	// Konstruktor bekommt Kameraobjekt
	public CollisionComputer(Camera cam) {
		this.cam = cam;
		this.objects = new ArrayList<CollisionObject>();
	}
	
	// Ein weiteres Objekt "anmelden"
	public void addCollisionObject(CollisionObject obj) {
		this.objects.add(obj);
	}
	
	public void testCollision() {
        
		float[] camCoords = cam.getCamPosition();
		for (int i=0; i<objects.size(); i++){
			if(Math.abs((objects.get(i).getX()-(-camCoords[0])))<objects.get(i).getNearX() &&
					((objects.get(i).getY()-(-camCoords[1])))<objects.get(i).getNearY() &&
					((objects.get(i).getZ()-(-camCoords[2])))<objects.get(i).getNearZ()) {
				objects.get(i).performAction();
			}
            
        }
        
	}
	
}
