/**
 * Created on 18.05.2006
 * @author PG3D modded by Lars Lttmann
 */
package big3d.listener;

import net.java.games.jogl.GL;
import net.java.games.jogl.GLCanvas;
import net.java.games.jogl.GLDrawable;
import net.java.games.jogl.GLEventListener;
import big3d.utils.GLSettings;
import big3d.worlds.*;


/**
 * Ein eigener GLEventListener
 */
public class GLListener implements GLEventListener{

    public static GLCanvas canvas = null;
    
    public GLListener(GLCanvas can){
        canvas = can;
    }
    
    public void init (GLDrawable gld) {
        GL gl = gld.getGL();
        
        // Fehlerzustand lschen!
        gl.glGetError();
        
        //Setting up the World:
        Big.getInstance().init(gld);
        if (gl.glGetError() != GL.GL_NO_ERROR)
            System.err.println("Fehler beim Initialisieren der Welt!");
        
        GLSettings.aktivateDepthBuffer(gl);
        if (gl.glGetError() != GL.GL_NO_ERROR)
            System.err.println("Fehler beim Einschalten des Tiefenpuffers!");
        
   }
    
    public void reshape (GLDrawable gld, int x, int y, int width, int height){
        // Welt aktualisieren:
        Big.getInstance().reshape(gld,x,y,width,height);
    }

    public void display (GLDrawable gld) {
        GL gl = gld.getGL();
        
        // Fehlerzustand lschen!
        gl.glGetError();
        
        // GL-Kram:
        GLSettings.startDrawing(gl);
        if (gl.glGetError() != GL.GL_NO_ERROR)
            System.err.println("Fehler beim Starten des Zeichenvorgangs!");
        
        
        //Welt zeichnen:
        Big.getInstance().draw(gld);
        if (gl.glGetError() != GL.GL_NO_ERROR)
            System.err.println("Fehler beim Zeichnen der Welt!");
      
   }
    
    public void displayChanged (GLDrawable gld, boolean arg1, boolean arg2) {
        /*---  wird nicht bentigt ---*/
    }
   
}


