/*
 * Created on 22.05.2006
 *
 */
package big3d.material;

import java.util.ArrayList;

import net.java.games.jogl.GLDrawable;

public class TextureLib {
    private static TextureLib instance = null;
    
    private ArrayList<TextureObject> textures;
    
    private TextureLib (){
        textures = new ArrayList<TextureObject>();
    }
    
    public static TextureLib getInstance(){
        if (instance == null)
            instance = new TextureLib();
        return instance;
    }
    
    public TextureObject getTexture(int id){
        return this.textures.get(id); 
    }
    
    public int getTextureID(TextureObject to){
        if (textures.size() !=0){
            for (int i =0; i< textures.size(); i++){
                if (textures.get(i).getFilename().equals(to.getFilename()))
                return i;
            }
        }
        //neu einfgen:
        textures.add(to);
        return textures.size()-1;
    }
    
    public void initAll(GLDrawable gld){
        if (this.textures.size() !=0){
            for (int i=0; i<this.textures.size(); i++){
                this.textures.get(i).initTexture(gld);
            }
        }
    }
}
