/*
 * Created on 15.05.2006
 *
 */
package big3d.objects;

import big3d.utils.MathHelper;
import net.java.games.jogl.GL;
import net.java.games.jogl.GLDrawable;

public class ComplexMeshFactory {
    
    public static int createTreeList(GLDrawable gld, int iteration){
        GL gl = gld.getGL();
        
        //erstelle eine DL fr einen Stamm:
        int list = DisplayListFactory.createList(gld, new Mesh(
                MeshFactory.createTrunk())); //tested !
        
        //diese je nach iteration aufrufen und in eine neue DL speichern:
        int result = gl.glGenLists(1);
        gl.glNewList(result, GL.GL_COMPILE);
        
        generateTree(gl, iteration, list);
         
        gl.glEndList();
        return result;
    }
    
    /**
     * Erstellt drei "Stmme" zum vorhandenen.
     * 
     * @param gl
     * @param iteration
     * @param displayList
     */
    private static void generateTree(GL gl, int iteration, int displayList){
        if (iteration == 0){
            //"Ast" fertig. Alte Matrix wieder drauf. und eine Rekursionstufe rauf
            gl.glPopMatrix();
            return;
        }
      
        //alte Matrix merken;
        //gl.glPushMatrix();

        //TODO: Richtiger Winkelkram:
        float rotXAchse = 90f;
        float rotYAchse = 60f; 
        float rotZAchse = 60f;
        
        float transXAchse = 0;
        float transYAchse = 16f;
        float transZAchse = 0;
        
        //Gren halbieren:
        gl.glScalef(0.5f, 0.5f, 0.5f);
        
        for (int i=1; i < 4;i++){
        gl.glPushMatrix();
        //rotieren:
        MathHelper.rotate(gl, rotXAchse, i* rotYAchse, rotZAchse);

        // verschieben:
        gl.glTranslatef(transXAchse, transYAchse, transZAchse);
        
        //zeichnen:
        gl.glCallList(displayList);
        
        gl.glPopMatrix();
        }
        
        iteration --;
       generateTree(gl, iteration, displayList);
    }
}
