/*
 * Created on 15.05.2006
 *
 */
package big3d.objects;

import net.java.games.jogl.GL;
import net.java.games.jogl.GLDrawable;

public class DisplayListFactory {
    /**
     * Erstellt eine DisplayListe fr ein Quadrat
     * @param gl
     * @param size
     * @return
     */
    public static int createCube(GLDrawable gld, float size){
        GL gl = gld.getGL();
        
        Mesh temp = new Mesh(MeshFactory.createCuboid(size, size, size));
        int list = gl.glGenLists(1);
        gl.glNewList(list, GL.GL_COMPILE);
        temp.draw(gld);
        gl.glEndList();
        
        return list;
    }
    
    /**
     * Erstellt eine DisplayListe zu einem Mesh.
     * 
     * @param gl
     * @param mesh
     * @return
     */
    public static int createList(GLDrawable gld, Mesh mesh){
        GL gl = gld.getGL();
        int list = gl.glGenLists(1);
        
        gl.glNewList(list, GL.GL_COMPILE);
         
        mesh.draw(gld);
         
        gl.glEndList();
        return list;
    }
    
    /**
     * Erstellt eine DisplayListe zu mehreren Mesh.
     * 
     * @param gl
     * @param mesh[]
     * @return
     */
    public static int createList(GLDrawable gld, Mesh[] mesh){
        GL gl = gld.getGL();
        int list = gl.glGenLists(1);
        
        gl.glNewList(list, GL.GL_COMPILE);
        
        for(int i = 0; i < mesh.length;i++) {
        	mesh[i].draw(gld);
        }
        
         
        gl.glEndList();
        return list;
    }
    
    
    /**
     * Lscht eine Displayliste.
     * 
     * @param gl
     * @param list
     */
    public static void deleteList(GL gl, int list){
        gl.glDeleteLists(1, list);
    }
}
