package big3d.objects;

import big3d.objects.md2.MD2Importer;
import net.java.games.jogl.GL;
import net.java.games.jogl.GLDrawable;
import net.java.games.jogl.util.GLUT;

/**
 * Erstellt ein beliebiges GLUT-Objekt und lt dieses drehen und die Gre 
 * ndern und anderen Schnick-Schnack!
 */

public class RotatingObject {
	
	private GL gl;
    private GLDrawable gld;
	private float rotqube;
	private GLUT glut;
	private float size;
	private float maxSize;
	private float minSize;
	private boolean switcher;
	private float x;
	private float y;
	private float z;
	private String type;
    
    //some type^^
    private int homer = -1;
    private int chicken = -1;
	
	public RotatingObject(GLDrawable gld, String type) {
        this.gld = gld;
		this.gl = gld.getGL();
		this.rotqube = 0;
		this.glut = new GLUT();
		this.size = 1.0f;
		this.maxSize = 10f;
		this.minSize = 0;
		this.switcher = true;
		this.x = 0;
		this.y = 40;
		this.z = 0;
		this.type = type;
	}
	
	public void draw() {
        gl.glTranslatef(x,y,z);// Translate Into The Screen 7.0 Units
		gl.glRotatef(rotqube,0.0f,1.0f,0.0f);// Rotate The cube around the Y axis
		gl.glRotatef(rotqube,1.0f,1.0f,1.0f);
		drawObject();
		float x = (rotqube + 0.9f)%360;
		this.rotqube = x;	
		pump();
	}   
	
	// Gre ndern
	private void pump() {
		if(switcher) {
			size += 0.01;
			if (size > maxSize) {
				switcher = false;
			}
		} else {
			size -= 0.01;
			if (size < minSize) {
				switcher = true;
			}
		}
	}
	
	public void drawObject() {
		if(type == "teapot") {
			glut.glutSolidTeapot(gl,size);
		}
		if(type == "cube") {
			glut.glutSolidCube(gl,size);
		}
		if(type == "dode") {
			glut.glutSolidDodecahedron(gl);
		}
		if(type == "octa") {
			glut.glutSolidOctahedron(gl);
		}
		if(type == "ico") {
			glut.glutSolidIcosahedron(gl);
		}
        if(type == "homer") {
            // movable ant:
            if (homer == -1){
                Mesh ant = MD2Importer.importModel("players/homer/tris.md2",1,0,0.3f);
                homer = DisplayListFactory.createList(gld, ant);
            }
            gl.glCallList(homer);
  
        }
        if(type == "chicken") {
            // movable ant:
            if (chicken == -1){
                Mesh ant = MD2Importer.importModel("models/items/chicken/tris.md2",1,0,0.3f);
                chicken = DisplayListFactory.createList(gld, ant);
            }
            gl.glCallList(chicken);
        }
	}
	
	public void setPosition(float x, float y, float z) {
		this.x = x;
		this.y = y;
		this.z = z;
	}
	
	public void setSize(float size, float minSize, float maxSize) {
		this.size = size;
		this.minSize = minSize;
		this.maxSize = maxSize;
	}
	
	public void setType(String type) {
		this.type = type;
	}
	
	
}
