package big3d.objects.partikel;

import big3d.utils.GLSettings;
import net.java.games.jogl.*;


public class Partikel {
		
	final float FOUNTAIN_PARAM_X_1 = 0.001f;
	final float FOUNTAIN_PARAM_Y_1 = 0.01f;
	final float FOUNTAIN_PARAM_Z_1 = 0.001f;
	final float FOUNTAIN_PARAM_X_2 = 500f;
	final float FOUNTAIN_PARAM_Y_2 = 1000f;
	final float FOUNTAIN_PARAM_Z_3 = 500f;
	
	private String type;
	
	private float paramX1;
	private float paramY1;
	private float paramZ1;
	private float paramX2;
	private float paramY2;
	private float paramZ2;
	
	
    private int myOpenGLID=-1;
    private boolean ready = false; 
    private int MAX_PARTICLES;
    private float[] position = new float[3];

    private Particle particles[];

    private int[] textures = new int[1];
    
    private byte red;
    private byte green;
    private byte blue;
    private float lifetime;
    private float decay;
    
    
	public Partikel(int maxParticles,float lifetime, float decay,byte red, byte green, byte blue,String type) {
		this.MAX_PARTICLES = 2000;
		particles = new Particle[MAX_PARTICLES];
		this.lifetime = lifetime;
		this.decay = decay;
		this.red = red;
		this.green = green;
		this.blue = blue;
		this.type = type;
		if(type == "fire") {
			this.paramX1 = 0.01f;
			this.paramY1 = 0.01f;
			this.paramZ1 = 0.01f;
			this.paramX2 = 50f;
			this.paramY2 = 1000f;
			this.paramZ2 = 50f;
			
		}
		if(type == "water") {
			this.paramX1 = 0.01f;
			this.paramY1 = 0.01f;
			this.paramZ1 = 0.01f;
			this.paramX2 = 500f;
			this.paramY2 = 500f;
			this.paramZ2 = 500f;
		}
	}
    
;
	
    private Particle createParticle() {
        Particle p = new Particle(lifetime, decay); //original (1f, 0,001f)
        // 							paramX1							paramX2						
        p.setSpeed(Particle.SPEED_X, paramX1 - (float) Math.random() / paramX2);	// richtung??
        p.setSpeed(Particle.SPEED_Y, paramY1 - (float) Math.random() / paramY2); //dicke?
        p.setSpeed(Particle.SPEED_Z, paramZ1 - (float) Math.random() / paramZ2);
        return p;
    }

    public byte[] getTextureData() {
        byte[] data = new byte[256 * 4 * 256];
        for (int i = 0; i < 256 * 4 * 256; i += 4) {
            data[i] = (byte) red; //rot
            data[i + 1] = (byte) green; //grn
            data[i + 2] = (byte) blue; //blau
        }
        for (int y = 0; y < 256; y++) {
            for (int x = 0; x < 256; x++) {
                int dx = x - 128;
                int dy = y - 128;
                int w = 50 - (int) Math.sqrt((double) (dx * dx + dy * dy)) * 2;
                if (w < 0)
                    w = 0;
                data[y * 256 * 4 + x * 4 + 3] = (byte) w;
            }
        }
        return data;
    }

    public void init(GL gl) {
    
        gl.glEnable(GL.GL_TEXTURE_2D);
        gl.glGenTextures(1, textures);
        
        this.myOpenGLID = textures[0];
        gl.glBindTexture(GL.GL_TEXTURE_2D, this.myOpenGLID);
        gl.glTexParameteri(GL.GL_TEXTURE_2D, GL.GL_TEXTURE_MAG_FILTER,
                GL.GL_LINEAR);
        gl.glTexParameteri(GL.GL_TEXTURE_2D, GL.GL_TEXTURE_MIN_FILTER,
                GL.GL_LINEAR);
        gl.glTexImage2D(GL.GL_TEXTURE_2D, 0, GL.GL_RGBA, 256, 256, 0,
                GL.GL_RGBA, GL.GL_UNSIGNED_BYTE, getTextureData());
        
        this.ready = true;

    }


    public void draw(GL gl) {
        if(!this.ready)
            this.init(gl);
        gl.glPushMatrix();
        gl.glTranslatef(position[0], position[1], position[2]);
        
        gl.glDepthMask(false);
        gl.glEnable(GL.GL_TEXTURE_2D);
        GLSettings.setPartikelEnv(gl);
        
        gl.glEnable(GL.GL_BLEND);
   
        gl.glBindTexture(GL.GL_TEXTURE_2D, this.myOpenGLID);
        for (int i = 0; i < MAX_PARTICLES; i++) {
       
        	Particle p = particles[i];
            if (p == null) {
                p = particles[i] = createParticle();
                break;
            }
            // Erstelle Fontne
            if(type == "fire") {
            	fire(p,i);
            }
            if(type == "water") {
            	fountain(p,i);
            }
            
           
            gl.glBlendFunc(GL.GL_SRC_ALPHA, GL.GL_ONE);
            
            gl.glBegin(GL.GL_QUADS);
            gl.glTexCoord2f(0.0f, 1.0f);
            gl.glVertex3f(p.getLocation(Particle.LOCATION_X) - 0.4f, p
                    .getLocation(Particle.LOCATION_Y) + 0.4f, p
                    .getLocation(Particle.LOCATION_Z));
            gl.glTexCoord2f(0.0f, 0.0f);
            gl.glVertex3f(p.getLocation(Particle.LOCATION_X) - 0.4f, p
                    .getLocation(Particle.LOCATION_Y) - 0.4f, p
                    .getLocation(Particle.LOCATION_Z));
            gl.glTexCoord2f(1.0f, 0.0f);

            gl.glVertex3f(p.getLocation(Particle.LOCATION_X) + 0.4f, p
                    .getLocation(Particle.LOCATION_Y) - 0.4f, p
                    .getLocation(Particle.LOCATION_Z));
            gl.glTexCoord2f(1.0f, 1.0f);
            gl.glVertex3f(p.getLocation(Particle.LOCATION_X) + 0.4f, p
                    .getLocation(Particle.LOCATION_Y) + 0.4f, p
                    .getLocation(Particle.LOCATION_Z));
            gl.glEnd();
        
        }
        
        gl.glDisable(GL.GL_BLEND);
        gl.glDisable(GL.GL_TEXTURE_2D);
        gl.glDepthMask(true);
        gl.glPopMatrix();
    }
    
    public void setPosition(float x, float y, float z){
        this.position[0] = x;
        this.position[1] = y;
        this.position[2] = z;
    }
    
    public void fountain(Particle p, int i) {
        // Prft ob Partikel auf 0 fllt und ersellt einen neuen
        if (p.getLocation(Particle.LOCATION_Y) < 0.0f)
            p = particles[i] = createParticle();
        // verringert die Geschwindigkeit des Partikels
        p.setSpeed(Particle.SPEED_Y,
                p.getSpeed(Particle.SPEED_Y) - 0.00004f);
        p.evolve();	
    }
    
    public void fire(Particle p, int i) {
        // Prft ob Partikel auf 0 fllt und ersellt einen neuen
        if (p.getLocation(Particle.LOCATION_Y) > 20.0f)
            p = particles[i] = createParticle();
        // verringert die Geschwindigkeit des Partikels
        p.setSpeed(Particle.SPEED_Y,
                p.getSpeed(Particle.SPEED_Y) + 0.001f);
        p.evolve();	
    }
    public void water(Particle p, int i) {
        // Prft ob Partikel auf 0 fllt und ersellt einen neuen
        if (p.getLocation(Particle.LOCATION_Y) > 20.0f)
            p = particles[i] = createParticle();
        // verringert die Geschwindigkeit des Partikels
        p.setSpeed(Particle.SPEED_Y,
                p.getSpeed(Particle.SPEED_Y) + 0.004f);
        
        p.evolve();	
    }
}
