package big3d.sound;
import jass.render.*;
import jass.engine.*;
import jass.generators.*;

public class JASSMotor  {
	ErraticLoopBuffer cylinders;
    SourcePlayer player;
    ModalObjectWithOneContact engineResonances;
    boolean isOn = true;
    float factor=1;
    float CylSpeed = 3;
    String syfile = "stick.sy";
    String wavfile = "car2.wav";
	
    public JASSMotor() {
        float srate = 44100.f;
        int bufferSize = 128*4;
        int bufferSizeJavaSound = 8*1024;
        
        cylinders = new ErraticLoopBuffer(srate,bufferSize,"src/big3d/sound/car2.wav");
        player = new SourcePlayer(bufferSize,bufferSizeJavaSound,srate);
        ModalModel mm = null;
        try {
            mm = new ModalModel("src/big3d/sound/stick.sy");
        } catch(java.io.IOException e) {
            System.out.println(this+" "+e);
        }
        engineResonances = new ModalObjectWithOneContact(mm,srate,bufferSize);
        try {
            player.addSource(engineResonances);
            engineResonances.addSource(cylinders);
        } catch(SinkIsFullException e) {
        }
        float speed0 = CylSpeed;
        cylinders.setSpeed(speed0);
        float beatupness0 = 0.04f;

        cylinders.setMisfireProb(beatupness0);
        start();
	}
   
    public void start() {
        player.start();
        isOn = true;
    }

    public void accelerate() {
    	if (CylSpeed <= 14.9) {
    		CylSpeed = CylSpeed +0.1f;
    		cylinders.setSpeed(CylSpeed);
    		System.out.println(CylSpeed);
    	}
    }
    
    public void decelerate() {
    	cylinders.setSpeed(3);
    	CylSpeed = 3;
    }
    
}
