/*
 * Created on 01.05.2006
 *
 */
package big3d.surface;

import net.java.games.jogl.GL;
import net.java.games.jogl.GLDrawable;
import big3d.material.MultiTextureHelper;
import big3d.objects.Mesh;


public class Quad extends Surface{
    
    public Quad(Mesh mesh, int a, int b, int c, int d){
        this.mesh = mesh;
        this.vertexIDs = new int[4];
        
        this.vertexIDs[0] = a;
        this.vertexIDs[1] = b;
        this.vertexIDs[2] = c;
        this.vertexIDs[3] = d;
    }
    
    public Quad(int[] edges){
        if (edges.length == 4){
            this.vertexIDs = new int[4];
            this.vertexIDs[0]= edges[0];
            this.vertexIDs[1]= edges[1];
            this.vertexIDs[2]= edges[2];
            this.vertexIDs[3]= edges[3];
        }
    }

    
    public void draw(GLDrawable gld, int maxTex){
        GL gl =gld.getGL();
        
        int m=0;
        gl.glBegin(GL.GL_QUADS);
        
        for (int i = 0; i < 4; i++){
            
            // Texturkoordinaten pro Textur setzen:
            for (int n =0; n<maxTex; n++){
                gl.glMultiTexCoord3fv(MultiTextureHelper.getTexture(n), 
                        this.mesh.getTexCoord(this.textureIDs.get(i)).getDir());
            }
       
            if (this.normalIDs.size()!=1)
                m=i;
            gl.glNormal3fv(this.mesh.getNormal(this.normalIDs.get(m)).
                     getDirection());
            gl.glVertex3fv(this.mesh.getVertex(this.vertexIDs[i]).
                    getDir());
            
        }
        gl.glEnd();
    }
    
    public void drawNoTex(GL gl){
        gl.glBegin(GL.GL_QUADS);
        int m=0;
        
        for (int i = 0; i < 4; i++){
            if (this.normalIDs.size()!=1)
                m=i;
        
            gl.glNormal3fv(this.mesh.getNormal(this.normalIDs.get(m)).
                    getDirection());
            gl.glVertex3fv(this.mesh.getVertex(this.vertexIDs[i]).
                    getDir());
            
        }
        gl.glEnd();
    }

}
