/*
 * Created on 01.05.2006
 *
 */
package big3d.surface;

import net.java.games.jogl.GL;
import net.java.games.jogl.GLDrawable;
import big3d.material.MultiTextureHelper;
import big3d.objects.Mesh;

public class Triangle extends Surface{   
    public Triangle(Mesh mesh, int a, int b, int c){
        this.mesh = mesh;
        this.vertexIDs = new int[3];
        
        this.vertexIDs[0] = a;
        this.vertexIDs[1] = b;
        this.vertexIDs[2] = c;
    }
    
    public Triangle(int[] edges){
        if (edges.length == 3){
            this.vertexIDs = new int[3];
            this.vertexIDs[0]= edges[0];
            this.vertexIDs[1]= edges[1];
            this.vertexIDs[2]= edges[2];
        }
    }

    
    public void draw(GLDrawable gld, int maxTex){
        GL gl =gld.getGL();
        
        int m=0; //hilfsvariable, um bei runden bzw 
        //unrunden normalen keine fehler zu bekommen
        
        gl.glBegin(GL.GL_TRIANGLES);
        for (int i = 0; i < 3; i++){
           
            // Texturkoordinaten pro Textur setzen:
            for (int n =0; n<maxTex; n++){
                gl.glMultiTexCoord2fv(MultiTextureHelper.getTexture(n), 
                        this.mesh.getTexCoord(this.textureIDs.get(i)).getDir());
            }
          
            //Normalen:
            if (this.normalIDs.size()!=1)
                m=i;
            gl.glNormal3fv(this.mesh.getNormal(this.normalIDs.get(m)).
                  getDirection());
            
            //Vertices:
            gl.glVertex3fv(this.mesh.getVertex(this.vertexIDs[i]).
                    getDir());
            
        }
        gl.glEnd();

    }
    
    public void drawNoTex(GL gl){
        int m=0; //hilfsvariable, um bei runden bzw 
        //unrunden normalen keine fehler zu bekommen
        
        gl.glBegin(GL.GL_TRIANGLES);
        for (int i = 0; i < 3; i++){
           
            //Normalen:
            if (this.normalIDs.size()!=1)
                m=i;
            gl.glNormal3fv(this.mesh.getNormal(this.normalIDs.get(m)).
                  getDirection());
            
            //Vertices:
            gl.glVertex3fv(this.mesh.getVertex(this.vertexIDs[i]).
                    getDir());
            
        }
        gl.glEnd();
    }
}
