package big3d.utils;

/**
 * Farbwert im RGBA-Float-Format
 * @author Martin Schmaeck, Lars Lttmann
 */
public class Color{

	float[] color;
	
	public Color() {
		this.color = new float[4];
		this.color[0] = .5f; 
		this.color[1] = .5f; 
		this.color[2] = .5f; 
		this.color[3] = 1f;
		// alpha = 1.0f <=> solid
	}

	public Color(Color c) {
		this.color = new float[4];
		this.color[0] = c.color[0];
		this.color[1] = c.color[1];
		this.color[2] = c.color[2];
		this.color[3] = c.color[3];
	}

	public Color(float r, float g, float b, float a) {
		this.color = new float[4];
		this.color[0] = r;
		this.color[1] = g;
		this.color[2] = b;
		this.color[3] = a;
	}

	public Color(float r, float g, float b) {
		this(r, g, b, 1.0f);
	}
	
    public Color(float[] color){
        this.color = new float[4];
        this.color[0] = color[0];
        this.color[1] = color[1];
        this.color[2] = color[2];
        this.color[3] = color[3];
    }
    
	
	public Object clone() {
		return new Color(this);
	}

    /**
     * @return Returns the color.
     */
    public float[] getColor() {
        return color;
    }
    
    public void setColorData(int i, float value){
    	color[i] = value;
    }
    
    public float getColorData(int i){
    	return color[i];
    }

}
