/*
 * Created on 21.05.2006
 *
 */
package big3d.utils;

import net.java.games.jogl.GL;
import net.java.games.jogl.GLDrawable;
import net.java.games.jogl.GLU;

public class GLSettings {
    public static float[] ambientModel = {0.4f, 0.4f, 0.4f, 1.0f};
    //  wie viele Texturen kann diese karte?
    public static int maxTex;

    // wie viele combiners sind mglich?
    public static int combiners;
    
    
    public static void setBlendingOn(GL gl){
        //Tiefenpuffer nur noch lesen:
        gl.glDepthMask(true);
        
        gl.glEnable(GL.GL_BLEND);
        gl.glBlendFunc(GL.GL_SRC_ALPHA, GL.GL_ONE_MINUS_SRC_ALPHA);
    }
    
    public static void setBlendingOff(GL gl){
        gl.glDisable(GL.GL_BLEND);
        
        //Tiefenpuffer wieder schreibbar machen.
        gl.glDepthMask(false);
     }
    
    public static void aktivateDepthBuffer(GL gl){
        gl.glEnable((GL.GL_DEPTH_TEST));
        gl.glDepthFunc(GL.GL_LEQUAL);
    }
    
    public static void init(GL gl){
        // Lichtberechnung aktivieren
        gl.glEnable(GL.GL_LIGHTING);
        //gl.glEnable(GL.GL_CULL_FACE);
        
        
        // maximal untersttzte Textur-Units feststellen:
        int[] temp = new int[1];
        gl.glGetIntegerv(GL.GL_MAX_TEXTURE_IMAGE_UNITS_ARB, temp);
        maxTex = temp[0];

        gl.glGetIntegerv(GL.GL_MAX_GENERAL_COMBINERS_NV, temp);
        combiners = temp[0];
        
        // aufrufe von gl.glColor3* ndern auch die Farben von...
        gl.glEnable(GL.GL_COLOR_MATERIAL);
        
        //... dem diffusen reflexionseigenschaften des Materials
        gl.glColorMaterial(GL.GL_FRONT,GL.GL_AMBIENT_AND_DIFFUSE);
    }
    
    public static void startDrawing(GL gl){
        gl.glEnable(GL.GL_LIGHTING);
        
        //Buffer leeren:
        gl.glClear(GL.GL_COLOR_BUFFER_BIT); // Color-Buffer Reset
        gl.glClear(GL.GL_DEPTH_BUFFER_BIT); // z-Buffer Reset
        
        //Zurcksetzen:
        gl.glLoadIdentity();
        
        //Lightmodel setzen:
        gl.glLightModelfv(GL.GL_LIGHT_MODEL_AMBIENT, ambientModel);
    }
    
    public static void initLight(GL gl){
        // aufrufe von gl.glColor3*/ 4* ndern auch die Farben von...
        gl.glEnable(GL.GL_COLOR_MATERIAL);
        
        //... dem diffusen reflexionseigenschaften des Materials
        gl.glColorMaterial(GL.GL_FRONT,GL.GL_AMBIENT_AND_DIFFUSE);
        
        // setzt ein lichtmodel, dass fr spekulares Licht in Verbindung mit Material besser ist.
        gl.glLightModeli(GL.GL_LIGHT_MODEL_COLOR_CONTROL, GL.GL_SEPARATE_SPECULAR_COLOR);
            
        gl.glLightModelfv(GL.GL_LIGHT_MODEL_AMBIENT, ambientModel);
    }
    
    public static void setDefaultTextureEnv(GL gl){
        // Texturumgebeung setzen:
        gl.glTexEnvi(GL.GL_TEXTURE_ENV, GL.GL_TEXTURE_ENV_MODE, GL.GL_MODULATE);
        
        //// Texturparameter:///
        // Wenn die Textur verkleinert werden soll:
        gl.glTexParameterf(GL.GL_TEXTURE_2D, GL.GL_TEXTURE_MIN_FILTER, GL.GL_LINEAR_MIPMAP_LINEAR);
        
        //Wenn die Textur grer gezeichnet werden soll
        gl.glTexParameterf(GL.GL_TEXTURE_2D, GL.GL_TEXTURE_MAG_FILTER, GL.GL_LINEAR );
        
        if (gl.glGetError() != GL.GL_NO_ERROR)
            System.err.println("Fehler beim Setzen der Texturparameter: MIN + MAG!");
        
        setTextureParamRepeat(gl);
        if (gl.glGetError() != GL.GL_NO_ERROR)
            System.err.println("Fehler beim Setzen der Texturparameter: WRAP!");
        
    }
    
    public static void setPartikelEnv(GL gl){
        // Texturumgebeung setzen:
        gl.glTexEnvi(GL.GL_TEXTURE_ENV, GL.GL_TEXTURE_ENV_MODE, GL.GL_REPLACE);
        
        //// Texturparameter:///
        // Wenn die Textur verkleinert werden soll:
        gl.glTexParameterf(GL.GL_TEXTURE_2D, GL.GL_TEXTURE_MIN_FILTER, GL.GL_LINEAR);
        
        //Wenn die Textur grer gezeichnet werden soll
        gl.glTexParameterf(GL.GL_TEXTURE_2D, GL.GL_TEXTURE_MAG_FILTER, GL.GL_LINEAR );
        
        if (gl.glGetError() != GL.GL_NO_ERROR)
            System.err.println("Fehler beim Setzen der Texturparameter: MIN + MAG!");
        
    }
    
    public static void setTextureEnvBlending(GL gl){
        // Texturumgebeung setzen:
        gl.glTexEnvi(GL.GL_TEXTURE_ENV, GL.GL_TEXTURE_ENV_MODE, GL.GL_BLEND);
    }
    
    public static void setTextureParamClamped(GL gl){
        gl.glTexParameterf(GL.GL_TEXTURE_2D, GL.GL_TEXTURE_WRAP_S, GL.GL_CLAMP_TO_BORDER);
        gl.glTexParameterf(GL.GL_TEXTURE_2D, GL.GL_TEXTURE_WRAP_T, GL.GL_CLAMP_TO_BORDER);
    }
    
    public static void setTextureParamRepeat(GL gl){
        gl.glTexParameterf(GL.GL_TEXTURE_2D, GL.GL_TEXTURE_WRAP_S, GL.GL_REPEAT);
        gl.glTexParameterf(GL.GL_TEXTURE_2D, GL.GL_TEXTURE_WRAP_T, GL.GL_REPEAT);
    }
    
    /**
     * 
     * @param gl
     */
    public static void setOrtho(GLDrawable gld, int h, int w){
        GLU glu = gld.getGLU();
        GL gl = gld.getGL();
        
        // switch to projection mode
        gl.glMatrixMode(GL.GL_PROJECTION);
        
        // save previous matrix which contains the 
        // settings for the perspective projection
        //gl.glPushMatrix();
        
        // set a 2D orthographic projection
        glu.gluOrtho2D(0, w, 0, h);
    }
    
    /**
     * 
     * @param gl
     */
    public static void resetProjectionMatrix(GL gl){
            gl.glMatrixMode(GL.GL_PROJECTION);
           // gl.glPopMatrix();
    }
    
    
    /*---------- Methoden ----------*/
    public static void updateAmbientLight(float value){
        if ((ambientModel[0] + value) > 1.0f){
            ambientModel[0] = 0;
            ambientModel[1] = 0;
            ambientModel[2] = 0;
        } else {
            ambientModel[0] += value;
            ambientModel[1] += value;
            ambientModel[2] += value;
        }
    }
}
