/*
 * Created on 01.05.2006
 *
 */
package big3d.utils;

public class Vertex {
    float[] dir = new float[3];
    
    public Vertex(float x, float y, float z){
        this.dir[0] = x;
        this.dir[1] = y;
        this.dir[2] = z;
    }
    
    public Vertex(float[] pos){
        if (pos.length == 3){
            this.dir[0] = pos[0];
            this.dir[1] = pos[1];
            this.dir[2] = pos[2];
        }
    }

    /**
     * @return Returns the dir.
     */
    public float[] getDir() {
        return dir;
    }
    
    public float getX(){
        return this.dir[0];
    }
    
    public float getY(){
        return this.dir[1];
    }
    
    public float getZ(){
        return this.dir[2];
    }

    public void multScale(GLVector v){
        this.dir[0] *= v.getX();
        this.dir[1] *= v.getY();
        this.dir[2] *= v.getZ();
    }
    
    public void multScale(float s){
        this.dir[0] *= s;
        this.dir[1] *= s;
        this.dir[2] *= s;
    }
    
    public void add(GLVector v){
        this.dir[0] += v.getX();
        this.dir[1] += v.getY();
        this.dir[2] += v.getZ();
    }
    
    
    
}
