/*
 * Created on 27.07.2006
 *
 */
package big3d.worlds;

import soal.SoalLite;
import big3d.collision.CollisionObject;
import big3d.material.Material;
import big3d.material.TextureLib;
import big3d.material.TextureObject;
import big3d.objects.DisplayListFactory;
import big3d.objects.FogObject;
import big3d.objects.LightFactory;
import big3d.objects.LightObject;
import big3d.objects.Mesh;
import big3d.objects.MeshFactory;
import big3d.objects.RotatingObject;
import big3d.objects.SkyBox;
import big3d.objects.md2.MD2Importer;
import big3d.objects.partikel.Partikel;
import big3d.sound.Soundengine;
import big3d.utils.Color;
import net.java.games.jogl.GL;
import net.java.games.jogl.GLDrawable;
import net.java.games.jogl.util.GLUT;

public class Big extends AbstractWorld {

    private static Big instance = null;

    /**
     * Zugriff
     * 
     * @return Eine Instanz dieser Welt
     */
    public static Big getInstance() {
        if (instance == null)
            instance = new Big();
        return instance;
    }

    @Override
    /**
     * Initalisiert alle Weltdaten:
     */
    public void init(GLDrawable gld) {
        GL gl = gld.getGL();

        super.init(gld);

        /*---- Welt Daten schreiben:  ---------*/

        // Tee-Kosmos
        RotatingObject tea = new RotatingObject(gld, "chicken");
        tea.setPosition(0, 50, 20);
        RotatingObject tea2 = new RotatingObject(gld, "homer");
        tea2.setSize(1, 7, 0);
        tea2.setPosition(0, 0, -20);
        RotatingObject tea3 = new RotatingObject(gld, "teapot");
        tea2.setSize(1, 4, 0);
        tea3.setPosition(0, 0, -20);
        RotatingObject tea4 = new RotatingObject(gld, "teapot");
        tea2.setSize(1, 2, 0);
        tea4.setPosition(0, 0, -20);

        this.rotatingGLUTObjects.add(tea);
        this.rotatingGLUTObjects.add(tea2);
        this.rotatingGLUTObjects.add(tea3);
        this.rotatingGLUTObjects.add(tea4);
        CollisionObject teaCosmos = new CollisionObject(0, 50, 20);
        collComp.addCollisionObject(teaCosmos);

        /*--------------COLLISION--------------*/
        // Lichter: //
        // Sonne:
        int sonneID = LightFactory.createNewLight();
        LightObject sonne = LightFactory.getLight(sonneID);
        sonne.setPosition4f(0f, 80f, -20f, 1f); // TODO: spter ndern
        sonne.setSpotCutoff(80f);
        sonne.setSpotDirection(0f, -1f, 0f);
        this.lights.add(sonneID);

        /*----------SOUND --------*/
        // init:
        Soundengine se = Soundengine.getInstance();
        SoalLite soal = SoalLite.getSoal();

        // Sounds
        int bg = soal.create("src/big3d/sound/bg/bgm2.ogg");
        se.setBGMusic(bg);

        /*--------SKYBOX ----------*/
        this.box = SkyBox.getInstance();

        /*---------- Nebel  ----------*/
        this.fog = new FogObject();

        /*----- MATERIAL ------*/
        // holz
        Material mat1 = new Material();
        int texID = TextureLib.getInstance().getTextureID(
                new TextureObject("src/big3d/md2/players/holz.jpg"));
        mat1.addTexture(texID);

        // himmel
        Material mat2 = new Material();
        int texID2 = TextureLib.getInstance().getTextureID(
                new TextureObject("src/big3d/textures/skys/dreams/front.jpg"));
        mat2.addTexture(texID2);

        // gras
        Material gras = new Material();
        int texID3 = TextureLib.getInstance().getTextureID(
                new TextureObject("src/big3d/textures/Floor/gras_gruen.jpg"));
        gras.addTexture(texID3);

        // stein (boden)
        Material stein = new Material();
        int steinID = TextureLib.getInstance().getTextureID(
                new TextureObject("src/big3d/textures/Floor/stone.jpg"));
        stein.addTexture(steinID);

        // stein (wand)
        Material wand = new Material();
        int wandID = TextureLib.getInstance().getTextureID(
                new TextureObject(
                        "src/big3d/textures/skys/dreams/front.jpg"));
        wand.addTexture(wandID);

        // holz
        Material holz = new Material();
        int texID4 = TextureLib.getInstance().getTextureID(
                new TextureObject("src/big3d/textures/Wood/Holz.jpg"));
        holz.addTexture(texID4);

        // dunkelholz
        Material dunkelholz = new Material();
        int texID5 = TextureLib.getInstance().getTextureID(
                new TextureObject("src/big3d/textures/Wood/Dark.jpg"));
        dunkelholz.addTexture(texID5);

        if (gl.glGetError() != GL.GL_NO_ERROR)
            System.err
                    .println("Fehler beim Initialisieren der Materialien der Welt!");

        /*-------------MESHES----------------------*/
        // movable cow:
        Mesh cow = MD2Importer.importModel("baseq2/players/cow/tris.md2", 1, 0);
        cow.setPosition(0f, 2.9f, -25f);
        cow.draw(gld);
        this.movableObjects.add(cow);

        // Boden erzeugen
        Mesh boden = new Mesh(MeshFactory.createPlateQuads(500));
        boden.autoTexCoords = true;
        boden.setRotate(-90, 0, 0);
        boden.setPosition(0, -5, 0);
        boden.setMaterial(stein);
        this.movableObjects.add(boden);

        // Haus bauen
        Mesh saeule1 = new Mesh(MeshFactory.createCuboid(50, 3, 3));
        saeule1.setMaterial(wand);
        saeule1.setPosition(-20, 0, -50);
        this.movableObjects.add(saeule1);

        Mesh saeule2 = new Mesh(MeshFactory.createCuboid(50, 3, 3));
        saeule2.setMaterial(wand);
        saeule2.setPosition(-60, 0, -50);
        this.movableObjects.add(saeule2);

        Mesh saeule3 = new Mesh(MeshFactory.createCuboid(50, 3, 3));
        saeule3.setMaterial(wand);
        saeule3.setPosition(-20, 0, -70);
        this.movableObjects.add(saeule3);

        Mesh saeule4 = new Mesh(MeshFactory.createCuboid(50, 3, 3));
        saeule4.setMaterial(wand);
        saeule4.setPosition(-60, 0, -70);
        this.movableObjects.add(saeule4);

        // und ein Dach druff
        Mesh dach = new Mesh(MeshFactory.createPyramide(40, 30, 30));
        dach.setMaterial(holz);
        dach.setPosition(-40, 40, -60);
        this.movableObjects.add(dach);

        // Lagerfeuer
        Mesh holzstueck = new Mesh(MeshFactory.createCuboid(1, 10, 1));
        holzstueck.setMaterial(dunkelholz);
        holzstueck.setPosition(-35, -4.5f, -57);
        this.movableObjects.add(holzstueck);

        Mesh holzstueck2 = new Mesh(MeshFactory.createCuboid(1, 10, 1));
        holzstueck2.setMaterial(dunkelholz);
        holzstueck2.setPosition(-35, -4.5f, -57);
        holzstueck2.setRotate(0, 45, 0);
        this.movableObjects.add(holzstueck2);

        Mesh holzstueck3 = new Mesh(MeshFactory.createCuboid(1, 10, 1));
        holzstueck3.setMaterial(dunkelholz);
        holzstueck3.setPosition(-35, -4.5f, -57);
        holzstueck3.setRotate(0, 90, 0);
        this.movableObjects.add(holzstueck3);

        Mesh holzstueck4 = new Mesh(MeshFactory.createCuboid(1, 10, 1));
        holzstueck4.setMaterial(dunkelholz);
        holzstueck4.setPosition(-35, -4.5f, -57);
        holzstueck4.setRotate(0, 135, 0);
        this.movableObjects.add(holzstueck4);

        if (gl.glGetError() != GL.GL_NO_ERROR)
            System.err.println("Fehler beim Initialisieren der Cuboiden!");

        /*------- Partikelsystem -------*/
        Partikel p = new Partikel(500, 1, 0.0001f, (byte) 150, (byte) 150,
                (byte) 150,"fire");
        p.setPosition(-35f, -4f, -57f);

        Partikel p2 = new Partikel(500, 1, 0.0001f, (byte) 250, (byte) 50,
                (byte) 50,"fire");
        p2.setPosition(-35f, -4f, -57f);

        Partikel p3 = new Partikel(500, 1, 0.001f, (byte) 255, (byte) 255,
                (byte) 0, "water");

        p3.setPosition(10f, -4f, -27f);

        this.partikel.add(p);

        this.partikel.add(p2);

        this.partikel.add(p3);

        p.draw(gl);
        p2.draw(gl);
        p3.draw(gl);
        
        if (gl.glGetError() != GL.GL_NO_ERROR)
            System.err.println("Fehler beim Partikelsystem!");

        // movable ant:

        Mesh ant = MD2Importer.importModel("baseq2/players/kenny/tris.md2", 1,
                0);

        ant.setRotate(0, 45, 0);

        ant.setPosition(12f, -2.3f, -25f);

        ant.draw(gld);

        this.movableObjects.add(ant);

    }

}
