/*
 * Created on 18.05.2006
 *
 */
package big3d.worlds;


import java.util.ArrayList;

import big3d.material.Material;
import big3d.material.TextureLib;
import big3d.material.TextureObject;
import big3d.objects.DisplayListFactory;
import big3d.objects.LightFactory;
import big3d.objects.LightObject;
import big3d.objects.Mesh;
import big3d.objects.MeshFactory;
import big3d.objects.md2.MD2Importer;
import big3d.utils.Color;
import net.java.games.jogl.GL;
import net.java.games.jogl.GLDrawable;

public class QuadsAndStuff extends AbstractWorld{
    private final int CUBOID_COUNTER = 5;
    private static QuadsAndStuff instance = null;
    
    private QuadsAndStuff(){}
    
    public static QuadsAndStuff getInstance(){
        if (instance == null)
            instance = new QuadsAndStuff();
        return instance;
    }
    
    public void init(GLDrawable gld){
        GL gl = gld.getGL();
        
        super.init(gld);
        if (gl.glGetError() != GL.GL_NO_ERROR)
            System.err.println("Fehler beim Initialisieren der abstrakten Welt!");
        
        // Licht:
       // this.lights = new ArrayList<Integer>();

        int id = LightFactory.createNewLight();
        LightObject light = LightFactory.getLight(id);
        light.setPosition4f(0f, 0f, 40f, 0f);
        light.turnOnLight(gl);
        
        this.lights.add(id);
        
        if (gl.glGetError() != GL.GL_NO_ERROR)
            System.err.println("Fehler beim Initialisieren der Lichter der Welt!");
        
        
        // solide Objekte:
        float x = -40f;
        
        Material mat1 = new Material();
        
        int texID = TextureLib.getInstance().getTextureID(new TextureObject("src/big3d/md2/baseq2/players/kenny/kenny.jpg"));
        mat1.addTexture(texID);
        if (gl.glGetError() != GL.GL_NO_ERROR)
            System.err.println("Fehler beim Initialisieren der Materialien der Welt!");
        
        
        for (int i = 0; i < CUBOID_COUNTER; i++){
            Mesh temp = new Mesh(MeshFactory.createCuboid(10f, 4, 15f));
            temp.setPosition(x, 0f, -20f);
            temp.setMaterial(mat1);
           // this.solidObjects.add(DisplayListFactory.createList(gld, temp));
            this.movableObjects.add(temp);
            x += 20f;
        }
        
        if (gl.glGetError() != GL.GL_NO_ERROR)
            System.err.println("Fehler beim Initialisieren der Cuboiden!");
        
        
        //movable Kenny:
        Mesh kenny = MD2Importer.importModel("baseq2/players/kenny/tris.md2",1,0);
        kenny.setPosition(5f, 0f, 30f);
        kenny.draw(gld);
        
        //movable cow:
        Mesh cow = MD2Importer.importModel("baseq2/players/cow/tris.md2",1,0);
        cow.setPosition(-5f, 0f, 30f);
        cow.draw(gld);
        
        //homer:
        Mesh homer = MD2Importer.importModel("players/homer/tris.md2", 1, 0);
        homer.setPosition(0f, 10f, 30f);
        homer.draw(gld);
        
        this.movableObjects.add(kenny);
        this.movableObjects.add(cow);
        this.movableObjects.add(homer);
        if (gl.glGetError() != GL.GL_NO_ERROR)
            System.err.println("Fehler beim Initialisieren der Movable Objects!");
        
        
        
        //transparentes Objekt:
        Mesh pyramide = new Mesh(MeshFactory.createPyramide(25f, 25f,30f));
        pyramide.setPosition(0f, 9.9f, -20f);
        Material pyramidMat = new Material();
        pyramidMat.setColor(new Color(1.0f, 0.3f, 0.3f, 0.5f));
        pyramidMat.setAmbientAndDiffuse(new Color(1.0f, 0.3f, 0.3f, 0.5f));
        pyramide.setMaterial(pyramidMat);
        this.transparentObjects.add(DisplayListFactory.createList(gld, pyramide));
        
        if (gl.glGetError() != GL.GL_NO_ERROR)
            System.err.println("Fehler beim Initialisieren der transparenten Objekte!");
        
    }

}
